#include <REGX51.H>

sbit CS_U2   = P3^4 ;
sbit READ_ADC   = P3^5 ;
sbit CONVERSION_DONE = P3^7 ;
sbit START_CONVERSION= P3^6 ;

#define  SAMPLECOUNT50 50

#define adc_port  P1 
#define seg_port  P0 
unsigned char ones,tens,hunds,digital_value,max=0,actuall_current,dec_current,actuall_volt  ;
unsigned char current_reads[SAMPLECOUNT50];

bit  flag = 1 ;
int average =0 ;

void conv(bit);
void delay_us(int);
void delay_ms(int);
void div23dig(unsigned char);
void disp ( char , char, char );
void current ();
void peak_det () ;
void voltage (void) ;
void serial_send(unsigned char dat);
void serial_init();

void main()
{
char i ;

					        adc_port = 0xff	;		
									P0 = 0Xff			;
									P3= 0xff		;	 
           //next lines useful for debug.. but can be removed	
								  serial_init();  //if used for debug messages
	                serial_send('X');  //stop compiler complaining


								while(1)
									{										
										voltage();  //take and sum 50 (SAMPLECOUNT50) readings
									  average /=SAMPLECOUNT50;
									  actuall_volt= (average * 20)/21 ;
										
										div23dig(actuall_volt);  //convert to 3 digits
										
									  for(i=0;i<40;i++)
										  {						
									       disp(ones,tens,hunds); 
											}
									  average = 0; 
	
										for(i=0;i<4;i++)
										 {
										   current();
									     peak_det();  
									   }	 

									  actuall_current = ((int)(max*8 ))/51 ;
									  
									  dec_current =  (((int)((((int)(max*8 ))%51)*10))/51);
										max =0;
										div23dig(actuall_current);
										for(i=0;i<40;i++)
											 {
													disp(ones,tens,hunds);
											 }
											 
								  }
}

void conv(bit x)
	{
		x=x;
		  	CS_U2 =0;  //enable U2
		    delay_us(1);
				START_CONVERSION=0;  //pull WR pin low.. then high to start conversion
				START_CONVERSION=1;
		    while(CONVERSION_DONE==1);  //wait for End of conversion
				
				READ_ADC=0;  //put data onto the bus
				digital_value=adc_port;
				READ_ADC=1;  //isolate bus
				
				//serial_send(result);  //debug can be printed in hex on virtual terminal
		
		     
		 
				/* 
				 else 
				{
				cs_1=1;
				cs=0;
				delay_us(1);
				cs=1;
				while(inter);
				cs=0;
				digital_value=adc_port;
				cs=1;	
				}
				 */
				 
	}


void delay_us( int us_count)
 {
    while(us_count!=0)
      {
         us_count--;
       }
   }
void delay_ms( int ms_count)
 {
        while(ms_count!=0)
         {
            delay_us(112);   /*delay_us is called to generate 1ms delay*/
             ms_count--;
            }
   }

void div23dig(unsigned char x )
 { 
	  hunds = x/100;
	  tens = (x%100)/10;
		ones = (x%100)%10;
	
 }
void disp ( char x , char y ,char z )
 { char  table[16]={0x40,0x79,0x24,0x30,0x19,0x12,0x02,0x78,0x00,0x10,0x08,0x03,0x46,0x21,0x06,0x0e};
	 if( z ==0 ) 
	     { 
				 z=y ; 
				 y=x ;
				 x=dec_current;
				 flag = 0;				 
			 } 
		 
	  seg_port = table[x] ;
		seg_port|=0x80;
	  P2=P2|4;
		delay_ms(10);
	  P2=P2&251;
	  seg_port=table[y];
		if(flag!=1) {seg_port&=0x7f ; flag =1 ;}
		else seg_port|=0x80;
	  P2=P2|2;
		delay_ms(10);
	  P2=P2&253;
	  seg_port=table[z];
		seg_port|=0x80;
	  P2=P2|1;
	  delay_ms(10);
		P2=P2&254;
	  
 
 }
	
void current (void )
{ 
	char i ; 
  bit a = 0;	
	 for (i=0;i< SAMPLECOUNT50;i++)
		{
			conv(a);
			current_reads[i]=digital_value ;
			 	
		 }	
	
}

void peak_det ()
	{ 
		unsigned char i=0;
	
	  while( i < SAMPLECOUNT50 )
		{ 
			if(max<=current_reads[i]) max=current_reads[i] ; 
			i++;
		}
	}
	
//Take 50 reading from one of the converters add sum in average
	void voltage (void)
 {  
	
	 bit a=1  ;
	 char x ;
	 average=0;
	 for(x=0;x< SAMPLECOUNT50;x++)
	    {
	      conv(a);  
			  average += digital_value ;
	
			}
 } 
	
 //serial port useful for adding test messages
 void serial_init()
{
	TMOD = 0x20;
	SCON = 0x50;
	TH1  = 0xFD; //Set baudrate to 9600 at 11.0592MHz
	TL1  = 0xFD;
	TR1  = 1;
	TI=1;
}
void serial_send(unsigned char dat)
	{
	while(!TI);
	TI = 0;
	SBUF = dat;
}